from dataclasses import dataclass
from os import stat
from xmlrpc.client import boolean
from fastapi import FastAPI, Response, status, HTTPException, Request
import psycopg2
import  psycopg2.extras
# from user import User
import time
from pydantic import BaseModel
from fastapi.middleware.cors import CORSMiddleware
import snowflake.connector
class User(BaseModel):    
    email: str
    password: str
    

class Project(BaseModel):    
    name: str
    description: str
    shared: bool= True
    created_by: str


app = FastAPI()

origins = [
    
    # "http://localhost.tiangolo.com",
    # "https://localhost.tiangolo.com",
    # "http://localhost",
    # "http://localhost:8080",
    # "http://127.0.0.1:8000"
]

app.add_middleware(
    CORSMiddleware,
    allow_origins=["*"],
    allow_credentials=True,
    allow_methods=["*"],
    allow_headers=["*"],
)

while True:
    try:
        conn = psycopg2.connect(host = 'localhost', 
                                database='postgres', user = 'postgres', password = 'Ayyappa123*')
        cursor = conn.cursor(cursor_factory=psycopg2.extras.DictCursor)
        print('Database connection was successful')
        break
    except Exception as error:
        print("Database connection failed")
        print("Error", error)
        time.sleep(2)

while True:
    try:
        conn1=snowflake.connector.connect(
        user = 'AMUNDRA',
        password= 'Hariharan123*',
        account ="WG50838.ap-south-1.aws",
        warehouse = "COMPUTE_WH",
        database='FASTAPI',        
        )     
        #create cursor
        curs1=conn1.cursor()
        #execute SQL statement
        # curs1.execute("select current date;")
        #fetch result
        print('Snowflake connection was successful')
        break
    except Exception as error:
        print("Snowflake connection failed")
        print("Error", error)
        time.sleep(2)

@app.post("/users")
def find_user(user: User):
    print(user)
    return {
        "message": 'user found successfully'
    }

@app.post("/projects", status_code= status.HTTP_201_CREATED)
async def create_project(project: Project):
        cursor.execute("INSERT INTO projects(name, description, shared, created_by) VALUES(%s, %s, %s, %s) RETURNING *",
            (project.name, project.description, project.shared, project.created_by))
        new_project = cursor.fetchone()
        conn.commit()
        return {"data" : new_project}

@app.get("/allprojects")
async def get_projects():
    # cur = conn.cursor(cursor_factory=psycopg2.extras.DictCursor)
    cursor.execute("SELECT id, name, description, shared FROM projects")
    projects = cursor.fetchall()    
    conn.commit()
    all_projects = []
    for row in projects:
        all_projects.append(dict(row))
    return{"data": all_projects}

@app.post("/suites", status_code= status.HTTP_201_CREATED)
async def create_suite(request: Request):
        # cursor.execute("INSERT INTO projects(name, description, shared, created_by) VALUES(%s, %s, %s, %s) RETURNING *",
        #     (project.name, project.description, project.shared, project.created_by))
        # new_project = cursor.fetchone()
        # conn.commit()
        body = await request.json()
        # print(body)
        cursor.execute("INSERT INTO suites(name, description) VALUES(%s, %s) RETURNING *",
        (body['suitename'], body['suitedescription']))
        new_suite = cursor.fetchone()
        conn.commit()
        suiteid = new_suite[0]    
        i = 0
        for eachiIteration in body['selectcase']:
            if eachiIteration == True:
                cursor.execute("INSERT INTO steps(name, description, type, table_details, suiteid) VALUES(%s, %s, %s, %s, %s) RETURNING *",
                    (body['name'][i], body['description'][i],
                    'generic',
                    body['table'][i],
                    suiteid))
                new_test = cursor.fetchone()
                conn.commit()
                print(new_test)
            i = i + 1
        
        return {"data" : "save successfull"}
@app.get("/alltests")
async def get_tests():
    # cur = conn.cursor(cursor_factory=psycopg2.extras.DictCursor)
    cursor.execute("SELECT * FROM steps")
    projects = cursor.fetchall()    
    conn.commit()
    all_tests = []
    for row in projects:
        all_tests.append(dict(row))
    return{"data": all_tests}

@app.delete("/suites/{id}")
async def delete_suite(id: int):
    cursor.execute("DELETE FROM suites WHERE id = %s RETURNING *", (str(id),))
    deleted_id = cursor.fetchone()
   
    if deleted_id == None:
        raise HTTPException(status_code = status.HTTP_404_NOT_FOUND,
                detail = f"Suite id with {id} not found")
    conn.commit()
    cursor.execute("DELETE FROM steps WHERE suiteid = %s RETURNING *", (str(id),))
    deleted_suiteid = cursor.fetchone()
    if deleted_suiteid == None:
        raise HTTPException(status_code = status.HTTP_404_NOT_FOUND,
                detail = f"Suite id with {id} not found")
    conn.commit()
    return {"data" : "suite has been successfully deleted"}

@app.get("/alltests")
async def get_tests():
    # cur = conn.cursor(cursor_factory=psycopg2.extras.DictCursor)
    cursor.execute("SELECT * FROM steps")
    projects = cursor.fetchall()    
    conn.commit()
    all_tests = []
    for row in projects:
        all_tests.append(dict(row))
    return{"data": all_tests}

@app.delete("/projects/{id}")
async def delete_project(id: int):
    cursor.execute("DELETE FROM projects WHERE id = %s RETURNING *", (str(id),))
    deleted_id = cursor.fetchone()
   
    if deleted_id == None:
        raise HTTPException(status_code = status.HTTP_404_NOT_FOUND,
                detail = f"Suite id with {id} not found")
    conn.commit()   
    return {"data" : "suite has been successfully deleted"}

@app.get("/testing")
async def execute_testcases():
    conn1=snowflake.connector.connect(
            user = 'ap-south-1.aws',
            password= 'Hariharan123*',
            warehouse = "COMPUTE_WH",
            database='FASTAPI',
            account ="ACCOUNTADMIN",
            schema ="PUBLIC")     
    #create cursor
    curs1=conn1.cursor()
    #execute SQL statement
    curs1.execute("select current date;")
    #fetch result
    print (curs1.fetchone()[0])
    return { 'data': curs1.fetchone()[0]}